from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
from Products import CMFTTWType
import string

content_edit_body="""
## Script (Python) "generatorvariant_content_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=id=''
##title=Edit content
##
from Products.Formulator.Errors import ValidationError, FormValidationError

REQUEST=context.REQUEST
form=context.getTypeInfo().form
try:
    args = form.validate_all(REQUEST)
except FormValidationError, e:
    # should not happen!
    args={'title':e}
    pass

# add title as it's not in the formulator form (but maybe should be)
args['title']=REQUEST.get('title','')

new_context = context.portal_factory.doCreate(context, id)

## EDIT the remaining fields
new_context.edit(**args)
context.plone_utils.contentEdit( context, id=id)
                                 
return ('success', context, {'portal_status_message':context.REQUEST.get('portal_status_message', 'Changes saved.')})
"""

content_edit_form_body="""
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"
      lang="en-US"
      metal:use-macro="here/main_template/macros/master">
<body>

   <div metal:fill-slot="main" 
        tal:define="rejection here/rejectAnonymous;
                    errors python:request.get('errors', {});
                    Iterator python:modules['Products.CMFPlone'].IndexIterator;
		    form python:here.getTypeInfo().form;
                    tabindex python:Iterator();">

    <h1 i18n:translate="">Edit 
	    <span tal:replace="python:here.getTypeInfo().title_or_id()" />
    </h1>
    
    <form name="edit_form"
          action="formulator_content_edit" 
          method="post" 
          enctype="multipart/form-data"
	tal:attributes="action request/URL"
	>

	<div class="group">
	<span class="legend">Base Data</span>

        <div class="row" 
             tal:attributes="style python:test(not getattr(here.portal_membership.getAuthenticatedMember(), 'visible_ids', ''), 'visibility:hidden;;position:absolute;;left:0;;top:0', '')"
             tal:define="error_id errors/getId | nothing;
	     id python:request.get('id', here.getId());"> 
            <div class="label required">
                <span i18n:translate="id">Name</span>
                <div id="id_help" 
                     i18n:translate="help_name"
                     class="help" 
                     style="visibility:hidden">
	        Enter the Name
    of the document. This is the part that will show up as part of the
    web address. This should be short, descriptive and preferrably not
    contain spaces, underscores or mixed case. Example:
    'expense-report-2002'
                </div>
            </div>
            
            <div class="field"
                  tal:attributes="class python:test(error_id, 'field error', 'field')" >

             <div tal:replace="error_id" />

                <input type="text" 
                       name="id" 
                       value="#"
                       size="30" 
                       onfocus="formtooltip('id_help',1)" 
                       onblur="formtooltip('id_help',0)"
                       tal:attributes="value id;"
                       />
             </div>

        </div>
	        <div class="row"
             tal:define="error_title errors/title |nothing;
                         title python: request.get('title', here.Title());"
                         >
          <div class="label required">
             <span i18:id="title">Title</span>
	      
	       <div id="title_help" 
		   i18n:translate="title_help"
		class="help" 
		style="visibility:hidden">
                Enter a title for this content. This will appear in the management screen and will appear as the text in a link to this item.
	      </div>
            </div>
            
            <div class="field"
                 tal:attributes="class python:test(error_title, 'field error', 'field')" >

                <div tal:replace="error_title" />


        <input type="text" 
               name="title" 
               value="" 
               size="30" 
               tal:attributes="value title;"
               onfocus="formtooltip('title_help',1)" 
               onblur="formtooltip('title_help',0)" 
               />

                </div>
        </div>

	</div>

	<tal:block tal:repeat="group form/get_groups">
	<metal:block metal:use-macro="here/formulator/macros/formulatorGroup" />
	</tal:block>


        <div class="row">
            <div class="label">&nbsp;</div>
            <div class="field" tal:define="process_creation request/process_creation|nothing;"> 
                <input class="context" 
                       type="submit" 
                       name="Change" 
                       value="Save" /> 
            </div>
	    </div>
      <input type="hidden" name="form_submitted" value="1" tal:attributes="value template/id" />

    </form>

</div>
	   
</body>
</html>
"""

content_view_body="""
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"
      lang="en-US"
      metal:use-macro="here/main_template/macros/master">

<body>

<div metal:fill-slot="main"
     tal:define="form python:here.getTypeInfo().form">

    <h1 tal:content="here/title_or_id">
    Title or id
    </h1>
    <tal:block tal:repeat="f form/get_fields">
    <div class="row">
	<div class="label" 
	     tal:define="name f/title_or_id"
	     tal:content="name">Name
	</div>
	<div class="field" 
	     tal:define="fid python:f.id"
	     tal:content="structure python:here.get(fid)">Wert
	</div>
    </div>
    </tal:block>
</div>

</body>

</html>
"""

content_validate_body="""
from Products.Formulator.Errors import ValidationError, FormValidationError
validator = context.portal_form.createForm()
validator.addField('id','String',required=1,)
validator.addField('title','String',required=1,)
errors = validator.validate(context.REQUEST, context.REQUEST.get('errors', None))

typ=context.portal_type
tool=container.portal_types

form=tool[typ].form

try:
    data=form.validate_all_to_request(context.REQUEST)
except FormValidationError, ve:
    for error in ve.errors:
         errors[error.field.id]=error.error_text
  

## TODO: Update to use ScriptStatus Object
if errors:
    return ('failure', errors, {'portal_status_message':'please correct the indicated errors.'})
else:
    return ('success', errors, {'portal_status_message':'Changes have been saved.'})
"""

def install(self,portal_type_id):
    """ install the skins """
    out=StringIO()

    out=addSkins(self,out,portal_type_id)
    out=addNavigation(self,out,portal_type_id)
    out=addValidation(self,out,portal_type_id)
    return out.getvalue()

def addSkins(self,out,portal_type_id):
    """ add skins """

    skins_tool = getToolByName(self, 'portal_skins')
    f = manage_addFolder(portal_type.id)
    if portal_type_id not in skins_tool.objectIds() :
        skins_tool._setObject(portal_type_id,f)
     
    skins = skins_tool.getSkinSelections()
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if portal_type_id not in path:
            try: path.insert(path.index('content'), portal_type_id)
            except ValueError:
                path.append(portal_type_id)
                 
            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skins_tool.addSkinSelection(skin, path)
            out.write("Added %s to %s skin\n" % (portal_type_id,skin))
        else:
            out.write("Skipping %s skin, %s is already set up\n" % (
                skin,portal_type_id))
    return out

def addNavigation(self,out,portal_type_id):
    """ add to the navigation tool """
    try:
	nav_tool = getToolByName(self, 'portal_navigation')
    except AttributeError:
	out.write('navigation tool not found. not installing\n')
	return out
    
    # add the transitions
    nav_tool.addTransitionFor(
	    'default',
	    '%s_content_edit' % portal_type_id,
	    'failure',
	    'portal_form/%s_edit_form' % portal_type_id)

    nav_tool.addTransitionFor(
	    'default',
	    '%s_content_edit' % portal_type_id ,
	    'success',
	    'action:view')

    nav_tool.addTransitionFor(
	    'default',
	    '%s_edit_form' % portal_type_id ,
	    'success',
	    'script:%s_content_edit' % portal_type_id )

    nav_tool.addTransitionFor(
	    'default',
	    '%s_edit_form' % portal_type_id ,
	    'failure',
	    'portal_form/%s_edit_form' % portal_type_id )

    out.write("added transitions to navigation tool\n")
    return out

def addValidation(self,out,portal_typei_id):
    """ add validation to the form tool """
    try:
	form_tool = getToolByName(self, 'portal_form')
    except AttributeError:
	out.write('form tool not found. not installing validation\n')
	return out

    form_tool.setValidators("%s_edit_form" % portal_type_id, 
	['validate_id', 'validate_%s_edit' % portal_type_id ])

    out.write("added validation to form tool\n")
    return out

