""" CMFTTW Type Information

configure the CMFTTWObject objects.
It is implemented as a TypeInformation object.

(C) 2003 by Christian Scholz/MrTopf of COM.lounge

"""
formulator_body="""
<metal:block metal:define-macro="formulatorGroup">
<div class="group" tal:attributes="class python:test(group=='', '','group')">
<span class="legend" tal:content="group">group</span>

    <span	tal:omit-tag="" 
	    tal:repeat="field python:form.get_fields_in_group(group)">

     <div class="row"
	 tal:define="e python:errors.get(field.id,None);
		     value python:request.get(field.id, here.get(field.id));"
		     >
       <div class="label " tal:attributes="class python:test(here.test_required(field),'label required','label')">
	 <span tal:content="python:field.get_value('title')">Teaser</span>
       </div>

     <div class="field"
	     tal:attributes="class python:test(e, 'field error', 'field')" >

	    <div tal:replace="e" />
		<textarea tal:replace="structure python:field.render(value=value)" />
	    </div>
     </div>
    </span>

</div>
</metal:block>
"""
test_required_body="""
## Script (Python) "test_required"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=field
##title=tests if a field if required
##

try:
    return field.get_value("required")
except KeyError:
    return 0
"""

content_edit_form_body="""
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"
      lang="en-US"
      metal:use-macro="here/main_template/macros/master">
<body>

   <div metal:fill-slot="main" 
        tal:define="rejection here/rejectAnonymous;
                    errors python:request.get('errors', {});
                    Iterator python:modules['Products.CMFPlone'].IndexIterator;
		    form python:here.getTypeInfo().form;
                    tabindex python:Iterator();">

    <h1 i18n:translate="">Edit 
	    <span tal:replace="python:here.getTypeInfo().title_or_id()" />
    </h1>
    
    <form name="edit_form"
          action="formulator_content_edit" 
          method="post" 
          enctype="multipart/form-data"
	tal:attributes="action request/URL"
	>

	<div class="group">
	<span class="legend">Base Data</span>

        <div class="row" 
             tal:attributes="style python:test(not getattr(here.portal_membership.getAuthenticatedMember(), 'visible_ids', ''), 'visibility:hidden;;position:absolute;;left:0;;top:0', '')"
             tal:define="error_id errors/getId | nothing;
	     id python:request.get('id', here.getId());"> 
            <div class="label required">
                <span i18n:translate="id">Name</span>
                <div id="id_help" 
                     i18n:translate="help_name"
                     class="help" 
                     style="visibility:hidden">
	        Enter the Name
    of the document. This is the part that will show up as part of the
    web address. This should be short, descriptive and preferrably not
    contain spaces, underscores or mixed case. Example:
    'expense-report-2002'
                </div>
            </div>
            
            <div class="field"
                  tal:attributes="class python:test(error_id, 'field error', 'field')" >

             <div tal:replace="error_id" />

                <input type="text" 
                       name="id" 
                       value="#"
                       size="30" 
                       onfocus="formtooltip('id_help',1)" 
                       onblur="formtooltip('id_help',0)"
                       tal:attributes="value id;"
                       />
             </div>

        </div>
	        <div class="row"
             tal:define="error_title errors/title |nothing;
                         title python: request.get('title', here.Title());"
                         >
          <div class="label required">
             <span i18:id="title">Title</span>
	      
	       <div id="title_help" 
		   i18n:translate="title_help"
		class="help" 
		style="visibility:hidden">
                Enter a title for this content. This will appear in the management screen and will appear as the text in a link to this item.
	      </div>
            </div>
            
            <div class="field"
                 tal:attributes="class python:test(error_title, 'field error', 'field')" >

                <div tal:replace="error_title" />


        <input type="text" 
               name="title" 
               value="" 
               size="30" 
               tal:attributes="value title;"
               onfocus="formtooltip('title_help',1)" 
               onblur="formtooltip('title_help',0)" 
               />

                </div>
        </div>

	</div>

	<tal:block tal:repeat="group form/get_groups">
	<metal:block metal:use-macro="here/formulator/macros/formulatorGroup" />
	</tal:block>


        <div class="row">
            <div class="label">&nbsp;</div>
            <div class="field" tal:define="process_creation request/process_creation|nothing;"> 
                <input class="context" 
                       type="submit" 
                       name="Change" 
                       value="Save" /> 
            </div>
	    </div>
      <input type="hidden" name="form_submitted" value="1" tal:attributes="value template/id" />

    </form>

</div>
	   
</body>
</html>
"""

content_view_body="""
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"
      lang="en-US"
      metal:use-macro="here/main_template/macros/master">

<body>

<div metal:fill-slot="main"
     tal:define="form python:here.getTypeInfo().form">

    <h1 tal:content="here/title_or_id">
    Title or id
    </h1>
    <tal:block tal:repeat="f form/get_fields">
    <div class="row">
	<div class="label" 
	     tal:define="name f/title_or_id"
	     tal:content="name">Name
	</div>
	<div class="field" 
	     tal:define="fid python:f.id"
	     tal:content="structure python:here.get(fid)">Wert
	</div>
    </div>
    </tal:block>
</div>

</body>

</html>
"""

content_validate_body="""
from Products.Formulator.Errors import ValidationError, FormValidationError
validator = context.portal_form.createForm()
validator.addField('id','String',required=1,)
validator.addField('title','String',required=1,)
errors = validator.validate(context.REQUEST, context.REQUEST.get('errors', None))

typ=context.portal_type
tool=container.portal_types

form=tool[typ].form

try:
    data=form.validate_all_to_request(context.REQUEST)
except FormValidationError, ve:
    for error in ve.errors:
         errors[error.field.id]=error.error_text
  

## TODO: Update to use ScriptStatus Object
if errors:
    return ('failure', errors, {'portal_status_message':'please correct the indicated errors.'})
else:
    return ('success', errors, {'portal_status_message':'Changes have been saved.'})
"""

from Products.CMFCore.TypesTool import TypeInformation
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName
from Products.Formulator.Form import ZMIForm
from Globals import InitializeClass, DTMLFile
from AccessControl import getSecurityManager, ClassSecurityInfo
from OFS.Folder import Folder
from cmfttwobject import CMFTTWObject
from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
import string

class CMFTTWTypeInformation(TypeInformation):
    """ create a ttw type via formulator """

    meta_type = "CMFTTW Type Information"
    security = ClassSecurityInfo()

    _properties = (TypeInformation._basic_properties
                  +TypeInformation._advanced_properties)

    manage_options=(
	    TypeInformation.manage_options +
	    ({'label'	: 'Fields',
	      'action'	: 'form/manage_workspace'},))

    security.declarePublic('isConstructionAllowed')
    def isConstructionAllowed(self, container):
	""" check for the existance of the form """

	form=getattr(self,'form',None)
	if not form: return 0
	if len(form.get_fields())==0: return 0
	return 1

    security.declarePublic('constructInstance')
    def constructInstance(self,container,id,*args,**kw):
	""" create an instance of this type """

	id=str(id)
	args= ( id, self )

	# this is actually the constructor method
	o=apply(CMFTTWObject, args, kw)
	container._setObject(id,o)
	# end of constructor

	ob=container._getOb(id)
	return self._finishConstruction(ob)

    def getForm(self):
	""" return the form object of this type """
	return self.form

InitializeClass(CMFTTWTypeInformation)

content_edit_body="""
## Script (Python) "generatorvariant_content_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=id=''
##title=Edit content
##
from Products.Formulator.Errors import ValidationError, FormValidationError

REQUEST=context.REQUEST
form=context.getTypeInfo().form
try:
    args = form.validate_all(REQUEST)
except FormValidationError, e:
    # should not happen!
    args={'title':e}
    pass

# add title as it's not in the formulator form (but maybe should be)
args['title']=REQUEST.get('title','')

new_context = context.portal_factory.doCreate(context, id)

## EDIT the remaining fields
new_context.edit(**args)
context.plone_utils.contentEdit( context, id=id)
                                 
return ('success', context, {'portal_status_message':context.REQUEST.get('portal_status_message', 'Changes saved.')})
"""

# create add form
manage_addCMFTTWTypeInformationForm=DTMLFile('dtml/addCMFTTWTypeInformationForm', globals())

def installNewType(self,portal_type_id):
    """ install the skins """
    NewTypeaddSkins(self,portal_type_id)
    NewTypeaddNavigation(self,portal_type_id)
    NewTypeaddValidation(self,portal_type_id)

def NewTypeaddSkins(self,portal_type_id):
    """ add skins """

    skins_tool = getToolByName(self, 'portal_skins')
    if portal_type_id not in skins_tool.objectIds() :
        skins_tool.manage_addFolder(portal_type_id)
        f = getattr(skins_tool,portal_type_id)
        f.manage_addProduct['PythonScripts'].manage_addPythonScript("test_required")
        ps=getattr(f,"test_required")
        ps.ZPythonScript_edit("",test_required_body)
        f.manage_addProduct['PythonScripts'].manage_addPythonScript("%s_content_edit" % portal_type_id)
        ps=getattr(f,"%s_content_edit" % portal_type_id)
        ps.ZPythonScript_edit("",content_edit_body)
        f.manage_addProduct['PythonScripts'].manage_addPythonScript("validate_%s_edit" % portal_type_id)
        ps=getattr(f,"validate_%s_edit" % portal_type_id)
        ps.ZPythonScript_edit("",content_validate_body)
        f.manage_addProduct['PageTemplates'].manage_addPageTemplate('%s_edit_form' % portal_type_id,text=content_edit_form_body)
        f.manage_addProduct['PageTemplates'].manage_addPageTemplate('%s_view' % portal_type_id,text=content_view_body)
        f.manage_addProduct['PageTemplates'].manage_addPageTemplate('formulator',text=formulator_body)

    skins = skins_tool.getSkinSelections()
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if portal_type_id not in path:
            try: path.insert(path.index('content'), portal_type_id)
            except ValueError:
                path.append(portal_type_id)
                 
            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skins_tool.addSkinSelection(skin, path)

def NewTypeaddNavigation(self,portal_type_id):
    """ add to the navigation tool """
    try:
	nav_tool = getToolByName(self, 'portal_navigation')
    except AttributeError:
	print "Error"
    
    # add the transitions
    nav_tool.addTransitionFor(
	    'default',
	    '%s_content_edit' % portal_type_id,
	    'failure',
	    'portal_form/%s_edit_form' % portal_type_id)

    nav_tool.addTransitionFor(
	    'default',
	    '%s_content_edit' % portal_type_id ,
	    'success',
	    'action:view')

    nav_tool.addTransitionFor(
	    'default',
	    '%s_edit_form' % portal_type_id ,
	    'success',
	    'script:%s_content_edit' % portal_type_id )

    nav_tool.addTransitionFor(
	    'default',
	    '%s_edit_form' % portal_type_id ,
	    'failure',
	    'portal_form/%s_edit_form' % portal_type_id )

    print "OK"

def NewTypeaddValidation(self,portal_type_id):
    """ add validation to the form tool """
    try:
	form_tool = getToolByName(self, 'portal_form')
    except AttributeError:
	print "Error"

    form_tool.setValidators("%s_edit_form" % portal_type_id, 
	['validate_id', 'validate_%s_edit' % portal_type_id ])

    print "OK"

def manage_addCMFTTWTypeInformation(self, add_meta_type, id=None,
    typeinfo_name=None, RESPONSE=None):
    """ add the TypeInfo and a form for it """
    tool=getToolByName(self, 'portal_types', None)
    if tool is None:
	return

    # prepare the FTI
    fti= { 
        'id'		 : id
      , 'meta_type'      : 'CMFTTWObject'
      , 'description'    : ""
      , 'icon'           : 'document_icon.gif'
      , 'product'        : 'CMFTTWType'
      , 'factory'        : 'addCMFTTWType'
      , 'immediate_view' : 'portal_form/%s_edit_form' % id
      , 'actions'        :
	( { 'id'            : 'view'
          , 'name'          : 'View'
          , 'action'        : '%s_view' % id
          , 'permissions'   : (
          CMFCorePermissions.View, )
	} 
      , { 'id'            : 'edit'
          , 'name'          : 'Edit'
          , 'action'        : 'portal_form/%s_edit_form' % id
          , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
	} 
      , { 'id'            : 'metadata'
          , 'name'          : 'Metadata'
          , 'action'        : 'metadata_edit_form'
          , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
	})
    }

    obj=apply(CMFTTWTypeInformation,(),fti)
    tool._setObject(id,obj)
    obj=self._getOb(id)

    # now add the Formulator form to the type info
    form=ZMIForm('form','CMFTTW Type Information Form')
    setattr(obj,'form',form)
    print "here!!"
    installNewType(self,id)
    print "finish"
    if RESPONSE is not None:
	RESPONSE.redirect('%s/manage_main' % self.absolute_url())

